using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
class Program
{
    struct broj
    {
        public int vred;
        public int index;
    }
    static int poredjenje(broj A, broj B)
    {
        if (A.vred > B.vred) return 1;
        else return -1;
    }

    static int binarna(broj[] x, int t)
    {
        int l = 0;
        int d = x.Length - 1;
        int s = l + (d - l) / 2;
        while (l <= d)
        {
            if (x[s].vred == t) return s;
            else if (x[s].vred < t)
            {
                l = s + 1;
                s = l + (d - l) / 2;
            }
            else
            {
                d = s - 1;
                s = l + (d - l) / 2;
            }
        }
        return ~s;
    }

    static int kojibroj(int a)
    {
        string binar = string.Empty;
        int k = a;
        while (a > 0)
        {
            binar += a % 2;
            a /= 2;
        }
        int t = binar.Length;
        int sum = 0;
        int ekspo = 1;
        for (int i = 0; i < t; i++)
        {
            sum += ekspo;
            ekspo *= 2;
        }
        int brojka = k ^ sum;
        return brojka;
    }

    static void Main()
    {
        StringBuilder ispis = new StringBuilder();
        int t = int.Parse(Console.ReadLine());
        for (int k = 0; k < t; k++)
        {
            int n = int.Parse(Console.ReadLine());
            string[] a = Console.ReadLine().Split();
            broj[] x = new broj[n + 1];
            int[] resenja = new int[n + 1];
            int[] koriscen = new int[n + 1];
            int suma = 0, max = 0, br1 = 0, br2 = 0, prosli;
            for (int i = 0; i < n + 1; i++)
            {
                x[i].vred = int.Parse(a[i]);
                x[i].index = i;
            }
            Array.Sort(x, poredjenje);
            for (int i = 0; i < n + 1; i++)
            {
                max = 0;
                prosli = -1;
                int index = binarna(x, kojibroj(x[n - i].vred));
                if (index >= 0 && koriscen[index] != 1 && koriscen[n - i] != 1)
                {
                    max = x[n - i].vred ^ x[index].vred;
                    koriscen[index] = 1;
                    koriscen[n - i] = 1;
                    suma += 2 * max;
                    resenja[x[n - i].index] = x[index].vred;
                    resenja[x[index].index] = x[n - i].vred;
                }
            }
            ispis.Append(suma + "\n");
            for (int i = 0; i < n + 1; i++)
            {
                ispis.Append(resenja[i] + " ");
            }
            ispis.Append("\n");
            suma = 0;
        }
        Console.WriteLine(ispis);
    }
}