using System;
using System.Collections.Generic;
using System.Collections.Immutable;
using System.ComponentModel;
using System.Threading.Tasks;

namespace iva
{
    struct grad
    {
        public int stanovnici;
        public bool prodavnica;
    }
    public class Program
    {
        static void sort(int n, grad[] gradovi)
        {
            for(int i=0;i<n;i++)
            {
                for(int j=i+1;j<n;j++)
                {
                    if (gradovi[i].stanovnici < gradovi[j].stanovnici)
                    {
                        grad pom = gradovi[i];
                        gradovi[i] = gradovi[j];
                        gradovi[j] = pom;
                    }
                }
            }
        }
        static int MinBroj(int n, grad[] gradovi, int minBroj)
        {
            int brProdavnica = 0;
            int brStanovnika = 0;
            sort(n, gradovi);
            if (!gradovi[0].prodavnica && gradovi[0].stanovnici >= minBroj)
                return 1;
            for (int i = 0; i < n; i++)
            {
                if (!gradovi[i].prodavnica)
                {
                    brStanovnika += gradovi[i].stanovnici;
                    brProdavnica++;
                    if (brStanovnika >= minBroj)
                        return brProdavnica;
                }
            }
            return -1;
        }
        static void Main(string[] args)
        {
            string[] ulaz = Console.ReadLine().Split(' ');
            int n = int.Parse(ulaz[0]);
            int k = int.Parse(ulaz[1]);
            ulaz = Console.ReadLine().Split(' ');
            grad[] gradovi = new grad[n];
            for (int i = 0; i < k; i++)
            {
                int el = int.Parse(ulaz[i]);
                gradovi[el - 1].prodavnica = true;
            }
            ulaz = Console.ReadLine().Split(' ');
            int minBroj = 0;
            for (int i = 0; i < n; i++)
            {
                gradovi[i].stanovnici = int.Parse(ulaz[i]);
                minBroj += gradovi[i].stanovnici;
            }
            minBroj /= 2;
            Console.WriteLine(MinBroj(n, gradovi, minBroj));
            Console.ReadLine();
        }
    }
}