#include <iostream>
#include <vector>
#include <string>
#include <queue>
#include <stack>
#include <map>
#include <fstream>
#include <algorithm>

int main()
{
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    long long n, k;
    std::cin >> n >> k;
    std::vector<long long> a(k);
    std::vector<long long> b(n);

    std::map<long long, bool> p;
    long long mon = 0;
    for (long long i = 0; i < k; i++) { std::cin >> a[i]; a[i]--; p[a[i]] = true; }
    for (long long i = 0; i < n; i++) { std::cin >> b[i]; mon += b[i]; }

    std::vector<std::pair<std::vector<long long>, long long>> segments;
    std::vector<long long> curr;
    long long currsum = 0;
    for (long long i = a[0]+1; i <= n+a[0]; i++) {
            //std::cout << i << " " << b[i%n] << " " << p[i%n] << " " << i%n << std::endl;
        if (p[i%n]) {
            if (curr.size() > 0) {
                segments.push_back({curr, currsum});
                curr.clear();
                currsum = 0;
            }
        }
        else {
            curr.push_back(b[i%n]);
            currsum += b[i%n];
        }
    }

    mon /= 2;

    if (segments.size() == 0) {
        std::cout << -1 << std::endl;
        return 0;
    }

    std::sort(segments.begin(), segments.end(), [](const std::pair<std::vector<long long>, long long>& s1, const std::pair<std::vector<long long>, long long>& s2) {
              return s1.second > s2.second;
              });
    long long allsum = 0, res = 0;
    bool sol = false;
    for (int i = 0; i < segments.size(); i++) {
        auto cs = segments[i].first;
        if (cs.size() == 1) {
            allsum += segments[i].second;
            res++;
            if (allsum > mon) {
                sol = true;
                break;
            }
            continue;
        }
        bool halved = (cs.size()-1)%2;
        long long m1 = halved*(cs[(cs.size()-1)/2]/2), m2 = halved*(cs[(cs.size()-1)/2+1]/2), m3 = segments[i].second;

        for (int j = 0; j < cs.size(); j++) {
            if (!halved) {
                if (j > cs.size()/2) {
                    m1 += cs[j];
                }
                else {
                    m2 += cs[j];
                }
            }
            else {
                if (j >= cs.size()/2) {
                    m1 += cs[j];
                }
                else if (j < cs.size()/2) {
                    m2 += cs[j];
                }
            }
        }
        //std::cout << m1 << " " << m2 << " " << cs[0] << "..." << cs[cs.size()-1] << " " << m3 << std::endl;
        if (allsum + m1 > mon || allsum + m2 > mon) {
            res += 1;
            sol = true;
            break;
        }
        if (allsum + m3 > mon) {
            res += 2;
            sol = true;
            break;
        }
        if (m1 == 0 && m2 != 0) {
            res++;
            allsum += m2;
        }
        else if (m1 != 0 && m2 == 0) {
            res++;
            allsum += m1;
        }
        else {
            res += 2;
            allsum += m3;
        }
    }

    if (sol) {
        std::cout << res << std::endl;
    }
    else {
        std::cout << -1 << std::endl;
    }

    return 0;
}